import os, sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *

class ValidateUi(QDialog):
    def __init__(self, validateParameters={}, parent=None):
        super(ValidateUi, self).__init__(parent)

        self.__validateParameters = validateParameters


        self.radio1 = QRadioButton()
        self.radio1.setText("&Progetto corrente")
        self.radio1.setChecked(True)

        self.radio2 = QRadioButton()
        self.radio2.setText("&Altro progetto")

        self.projRadio = QButtonGroup()
        self.projRadio.addButton(self.radio1)
        self.projRadio.addButton(self.radio2)

        self.projTextedit = QLineEdit()
        self.projTextedit.setMinimumWidth(300)
        self.projChooseButton = QPushButton("Scegli...")

        buttonBox = QDialogButtonBox(QDialogButtonBox.Ok|QDialogButtonBox.Cancel)

        buttonLayout = QHBoxLayout()
        buttonLayout.addStretch()
        buttonLayout.addWidget(buttonBox)

        chooseDirLayout = QHBoxLayout()
        chooseDirLayout.addStretch()
        chooseDirLayout.addWidget(self.projTextedit)
        chooseDirLayout.addWidget(self.projChooseButton)

        self.radioV3 = QRadioButton("versione 3.2")
        self.radioV4 = QRadioButton("versione 4")
        self.radioV4.setChecked(True)

        versionLayout = QVBoxLayout()
        versionLayout.addWidget(self.radioV3)
        versionLayout.addWidget(self.radioV4)

        self.versionGroupbox = QGroupBox("Scegli la versione")
        self.versionGroupbox.setLayout(versionLayout)
        self.versionGroupbox.setEnabled(False)

        self.radioShp = QRadioButton("Shapefile")
        self.radioMdb = QRadioButton("Geodatabase")
        self.radioShp.setChecked(True)

        formatLayout = QVBoxLayout()
        formatLayout.addWidget(self.radioShp)
        formatLayout.addWidget(self.radioMdb)

        self.formatGroupbox = QGroupBox("Scegli il formato di archiviazione")
        self.formatGroupbox.setLayout(formatLayout)
        self.formatGroupbox.setEnabled(False)

        paramsLayout = QHBoxLayout()
        paramsLayout.addWidget(self.formatGroupbox)
        paramsLayout.addWidget(self.versionGroupbox)

        self.projGroupbox = QGroupBox("Imposta il percorso del progetto")
        self.projGroupbox.setLayout(chooseDirLayout)
        self.projGroupbox.setEnabled(False)


        layout = QHBoxLayout()
        layout.addWidget(self.radio1)
        layout.addWidget(self.radio2)


        mainLayout = QVBoxLayout()
        mainLayout.addLayout(layout)
        mainLayout.addWidget(self.projGroupbox)
        mainLayout.addLayout(paramsLayout)
        mainLayout.addLayout(buttonLayout)

        self.setLayout(mainLayout)
        self.setWindowTitle("Validazione")
        self.setMinimumWidth(300)


        self.connect(self.radio1, SIGNAL("clicked()"), self.isOtherProj)
        self.connect(self.radio2, SIGNAL("clicked()"), self.isOtherProj)
        self.connect(self.projChooseButton, SIGNAL("clicked()"), self.chooseDir)
        self.connect(buttonBox, SIGNAL("accepted()"), self, SLOT("accept()"))
        self.connect(buttonBox, SIGNAL("rejected()"), self, SLOT("reject()"))


    def isOtherProj(self):
        if self.radio2.isChecked():
            self.projGroupbox.setEnabled(True)
            self.versionGroupbox.setEnabled(True)
            self.formatGroupbox.setEnabled(True)
            #### Rimuovere dopo implementazione
            self.radioMdb.setEnabled(False)
            self.radioV3.setEnabled(False)
            return
        self.projGroupbox.setEnabled(False)
        self.versionGroupbox.setEnabled(False)
        self.formatGroupbox.setEnabled(False)

    def chooseDir(self):
        dirBrowser = QFileDialog()
        dirBrowser.setFileMode(QFileDialog.Directory)
        if dirBrowser.exec_():
            self.projTextedit.setText(str(dirBrowser.selectedFiles()[0]))

    def accept(self):
        if self.radio2.isChecked():
            self.__validateParameters["path"] = str(self.projTextedit.text())
        if self.radioV3.isChecked():
            self.__validateParameters["version"] = 3
        if self.radioMdb.isChecked():
            self.__validateParameters["type"] = "mdb"

        QDialog.accept(self)


if __name__ == "__main__":
    app = QApplication(sys.argv)
    form = ValidateUi()
    form.show()
    form.exec_()
